
Uses CRT;

Type ted = Char;

     tree = ^node;
     node = record
            elem:ted;
            left:tree;
            right:tree;
     end;

Var n, level : integer;
        root : tree;
           I : word;
     SL,SR,S : String;

Function ItemRoot(Str:String):Char;
Begin
     ItemRoot := Str[1];
End;


Function ItemLeft(Str:String):String;
Var I : Integer;
    A : Array[1 .. 40] Of Byte;
    C : Byte;
    StrLeft, StrRight : String;

Begin
     For I := 1 To 40 Do A[I] := 0;

     Delete(Str,Length(Str),1);
     Delete(Str,1,2);

     C := 0;
     For I := 1 To Length(Str) Do Begin
         If Str[I] = '(' Then C := C + 1;
         If Str[I] = ')' Then C := C - 1;
         A[I] := C;
     End;

     StrLeft := Str;
     StrRight := Str;

     I := 1;
     While (Str[I] <> ',') Or (A[I] <> 0) Do I := I + 1;
     C := I;

     Delete(StrRight,1,C);
     Delete(StrLeft,C,Length(StrLeft));

     ItemLeft := StrLeft;
End;

Function ItemRight(Str:String):String;
Var I : Integer;
    A : Array[1 .. 40] Of Byte;
    C : Byte;
    StrLeft, StrRight : String;

Begin
     For I := 1 To 40 Do A[I] := 0;

     Delete(Str,Length(Str),1);
     Delete(Str,1,2);

     C := 0;
     For I := 1 To Length(Str) Do Begin
         If Str[I] = '(' Then C := C + 1;
         If Str[I] = ')' Then C := C - 1;
         A[I] := C;
     End;

     StrLeft := Str;
     StrRight := Str;

     I := 1;
     While (Str[I] <> ',') Or (A[I] <> 0) Do I := I + 1;
     C := I;

     Delete(StrRight,1,C);
     Delete(StrLeft,C,Length(StrLeft));

     ItemRight := StrRight;
End;

Function DelSpase(S:String):String;
Var T : String;
    I : Word;
Begin
     T := '';
     For I := 1 To Length(S) Do Begin
         If S[I] <> ' ' Then T := T + S[I];
     End;
     DelSpase := T;
End;

Procedure PrintTree(var p: tree; h: integer);
Var i: integer;
Begin
     If p <> nil then Begin
        PrintTree(p^.right, h + 1);
        For i:=1 to h do write('    ');
        Writeln(p^.elem);
        PrintTree(p^.left, h + 1);
      End;
End;

Procedure AddTree(NewTree : tree; StrLeft, StrRight:String);
Var nl, nr : Integer;
    NewNode : tree;
    StrRightL, StrRightR, StrLeftL, StrLeftR : String;

Begin

     If (NewTree^.right = nil) AND (StrRight <> '') Then Begin
           New(NewNode);
           NewNode^.elem :=  ItemRoot(StrRight);
           NewNode^.left  := nil;
           NewNode^.right := nil;
           NewTree^.right := NewNode;
           AddTree(NewNode, ItemLeft(StrRight), ItemRight(StrRight));
     End;

     If (NewTree^.left = nil) AND (StrLeft <> '') Then Begin
           New(NewNode);
           NewNode^.elem :=  ItemRoot(StrLeft);
           NewNode^.left  := nil;
           NewNode^.right := nil;
           NewTree^.left := NewNode;
           AddTree(NewNode, ItemLeft(StrLeft), ItemRight(StrLeft));
     End;
End;

Function CalcTree(NewTree : tree):Longint;
Var code: Integer;
    Result : Longint;
Begin
     Case NewTree^.elem Of
     'm' : Result := (CalcTree(NewTree^.left) - CalcTree(NewTree^.right)) mod 10;
     'p' : Result := (CalcTree(NewTree^.left) + CalcTree(NewTree^.right)) mod 10;
     Else Val(NewTree^.elem, Result, code);
     End;
     CalcTree := Result;
End;

Begin
     ClrScr;

     S := 'm (9, p (p (3, 5), m (3, 8)))';
     S := DelSpase(S);
     WriteLn('ࠦ: ',S);
     WriteLn;

     New(Root);
     Root^.elem := ItemRoot(S);
     Root^.left := nil;
     Root^.right := nil;

     AddTree(Root, ItemLeft(S), ItemRight(S));

     WriteLn('ॢ ࠦ ( ᫥ ࠢ):');
     PrintTree(Root, 1);
     WriteLn;

     WriteLn(': ',S,'=',CalcTree(Root));

     Readln;
End.
